package edu.wpi.ejutr;

import org.eclipse.ui.plugin.*;
import org.eclipse.jface.resource.ImageDescriptor;
import org.osgi.framework.BundleContext;

import edu.wpi.ejutr.debug.*;
import edu.wpi.ebob.*;
import edu.wpi.ebob.model.*;

/**
 * The main plugin class to be used in the desktop.
 * 
 * @author Ben Mohlenhoff - <a href="mailto:bigben@wpi.edu">bigben@wpi.edu</a>
 */
public class EjutrPlugin extends AbstractUIPlugin {

	//The shared instance.
	private static EjutrPlugin plugin;
	private static ObjBenchPlugin ebobPlugin;
	
	// handle to the object bench
	private static ObjectBench objBenchHandle;

	/**
	 * The constructor.
	 */
	public EjutrPlugin() {
		plugin = this;	
		ebobPlugin = ObjBenchPlugin.getDefault();
		objBenchHandle = ebobPlugin.getBench();
		DebugDialog.off();
		//MessageDialog.openInformation(Display.getCurrent().getActiveShell(),
        //        "E-JUTR DEBUG DIALOG", "EjutrPlugin constructor");
	}

	/**
	 * This method is called upon plug-in activation
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		//MessageDialog.openInformation(Display.getCurrent().getActiveShell(),
        //        "E-JUTR DEBUG DIALOG", "ejutr.start called");
		//edu.wpi.ejutr.debug.DebugDialog.show("EJUTR loaded + started");
		//TODO: listener code added		
		//objBenchHandle.addObjectBenchListener(ebobListener, true); //TODO: not sure if we need to send messages for everything already in the bench
		
		// 2/3/06 - listener code moved into start/stop actions
		
	}

	/**
	 * This method is called when the plug-in is stopped
	 */
	public void stop(BundleContext context) throws Exception {
		super.stop(context);
		//MessageDialog.openInformation(Display.getCurrent().getActiveShell(),
        //        "E-JUTR DEBUG DIALOG", "ejutr stop called");
		//TODO: listener code added
		//objBenchHandle.removeObjectBenchListener(ebobListener);
		// 2/3/06 - listener code moved into start/stop actions
		plugin = null;
		ebobPlugin = null;
	}

	/**
	 * Returns the shared instance.
	 */
	public static EjutrPlugin getDefault() {
		return plugin;
	}

	/**
	 * Returns an image descriptor for the image file at the given
	 * plug-in relative path.
	 *
	 * @param path the path
	 * @return the image descriptor
	 */
	public static ImageDescriptor getImageDescriptor(String path) {
		return AbstractUIPlugin.imageDescriptorFromPlugin("edu.wpi.ejutr", path);
	}
	
	/**
	 * Returns the handle to the object bench.
	 * 
	 * @return the handle to the object bench.
	 */
	public static ObjectBench getBenchHandle() {
		return objBenchHandle;
	}
	
}
